<?php
/**
 * @copyright (c) Kufer Software GmbH, Loisachstrasse 4, D-84453 Mühldorf
 */

namespace Kufer\KuferTools\Mitarbeiter\KursVorschlag\KursVorschlag;

class KursVorschlagAbsendenController extends \Kufer\KuferTools\Basis\Controller\ToolController
{
  
  protected function getUseCase(): \Kufer\KuferTools\Basis\UseCase\UseCase
  {
    return new KursVorschlagAbsendenUseCase(
      $this->getRequestObj()
    );
  }

  
  protected function getRequestObj()
  {
    $requestObj = new \Kufer\KuferTools\Basis\KursPlanung\KursVorschlag\KursVorschlagAbsendenRequest();

    $wssHandler = new \Kufer\KuferTools\Utils\WssHandler(KursVorschlagAbsendenUseCase::getToolSectionId(), KursVorschlagAbsendenUseCase::getUser());
    $requestObj->columnValues = $wssHandler->getColumnValuesFromPost();
    $requestObj->wssHandler = $wssHandler;

    $action = $this->getActionVal();

    return $this->handleXsrf($requestObj, $action);
  }

  
  protected function getPresenter($pUseCaseResponse)
  {
    return new \Kufer\KuferTools\Basis\KursPlanung\KursVorschlag\KursVorschlagFormularPresenter($pUseCaseResponse);
  }

  protected function getControllerToForward($pUseCaseResponse)
  {
    if (count($pUseCaseResponse->wrongFields) > 0) {
      return new KursVorschlagNachAbsendenController($pUseCaseResponse->statusCodes, $pUseCaseResponse->wrongFields, $pUseCaseResponse->changedKursplanung);
    } else {
      return null;
    }
  }
}